;-- http://radiohlam.ru -  ,   
;--     9,6 
.device ATtiny13
.include "tn13def.inc"
.list
;--   
.def   w=r16		;    
.def   Flags=r17    ; 0-  = 1 -        
.def   TTimer=r18	;             

.equ   TTW=15		;           =255-15
.equ   TTC=180      ;    (    80  
					;     -  ,   ) (533 us)
;--------------------------
.equ   IR_IN=2      ;   PB2
.equ   BUTTON=0     ;    PB0
.equ   LDIODE=4     ;   PB4
.equ   RELE=3       ;   PB3

;--  
; SPL -   
; ACSR -  
; DDRB -   
; PORTB -  
; GIMSK -     
; PCMSK -      
; TCCR0B -  
; TIMSK0 -   
; TCNT0 -  
; OCR0A -   
; TIFR0 -    
;--   
      .cseg
      .org 0
      rjmp Init				;    
;--  
      reti					; INT0
      rjmp PinChange		; Pin Change
      rjmp TimerOverflow	; Timer
      reti					; EEPROM
      reti					; comparator
      reti					; timer compare match A
      reti					; timer compare match B
      reti					; watchdog
      reti					; ADC
;--  
Init: ldi w,RAMEND				;   
      out SPL,w					;     RAM
      sbi ACSR,7				;  
      ldi w,1<<LDIODE|1<<RELE	;      (1-, 0-)
      out DDRB,w
      com w						;   
      cbr w,1<<IR_IN			; ( IR_IN), 
      out PORTB,w				;   = 0
;--    
      ldi w,1<<IR_IN			;  ,     
      out PCMSK,w
      ldi w,1<<PCIE				;   PinChange
	  out GIMSK,w
;--   (      )
      clr w
      out TCCR0A,w		;  OCR0A, OCR0B , Normal Mode
      ldi w,TTC	        ;    
      out TCNT0,w
      ldi w, 1<<TOIE0	;   
	  out TIMSK0,w
	  ldi TTimer,TTW    ;   
;--    
      ldi w,0b00000100	;  , Normal Mode, /256
      out TCCR0B,w
      sei
;--  
Start:
      sbic PINB, BUTTON     ;    (0- ) - 
	  rjmp Start
      sbr Flags,1<<0		;  0-  (      )
      rjmp Start

;----------------------------------------------------------------------
;----------------------------------------------------------------------
;--- Interrupts ---
;---    -   ;     
TimerOverflow:
	  cbi PORTB, LDIODE ;   ( )
      brtc TR_and_TF    ;   T  - 
Work: sbi PORTB, RELE   ;  
      rjmp Work         ;     
;---      -    
PinChange:
	  sbi PORTB, LDIODE     ;  
TR_and_TF:                  ; (timer reset and flag test)
      ldi w,TTC	            ;     ( )
      out TCNT0,w
	  sbrs Flags,0          ;  ,  0-  
	  reti                  ; 
      inc TTimer            ;        
	  breq Set_Work         ;   -   
	  reti                  ; 
Set_Work:
      set                   ;   T
	  reti                  ; 
;------------------
